


#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

//#include <Fonts/FreeMono9pt7b.h>
#include <Fonts/FreeSans9pt7b.h>
#include <Fonts/FreeSans12pt7b.h>

#include <Fonts/FreeSansBold9pt7b.h>
#include <Fonts/FreeSansBold12pt7b.h>
#include <Fonts/FreeSansBold18pt7b.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET     4 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);


#define LOGO_HEIGHT   16
#define LOGO_WIDTH    16
static const unsigned char PROGMEM logo_bmp[] =
{ B00000000, B11000000,
  B00000001, B11000000,
  B00000001, B11000000,
  B00000011, B11100000,
  B11110011, B11100000,
  B11111110, B11111000,
  B01111110, B11111111,
  B00110011, B10011111,
  B00011111, B11111100,
  B00001101, B01110000,
  B00011011, B10100000,
  B00111111, B11100000,
  B00111111, B11110000,
  B01111100, B11110000,
  B01110000, B01110000,
  B00000000, B00110000 };
  
//-----------------------------------------------------------------------------------------------------

// knihovna pro analog modul
#include "HX711.h"  // Arduino pin 2 -> HX711 CLK  X   3 -> DOUT
#define DOUT  3
#define CLK  2
HX711 scale(DOUT, CLK);
float calibration_factor = -25700; //-7050 worked for my 440lb max scale setup

//-----------------------------------------------------------------------------------------------------

float hmotnost_min = 0;
float hmotnost_max = 0;
float hmotnost_aktual = 0;
float napeti = 4.0;
int bat = 0;

// měření baterie
#define analogPin A1


void setup() {


  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // komunikační adresa displeje

  display.clearDisplay();
  display.setFont(&FreeSansBold18pt7b);
  display.setTextColor(SSD1306_WHITE);
  display.setCursor(15, 40);
  display.println(F("CJUZ"));
  //display.drawLine(0, 4, 128, 4, SSD1306_WHITE);

  display.setFont();
  display.setTextSize(1);
  display.setTextColor(SSD1306_WHITE);
  display.setCursor(10, 50);
  display.println(F("cjuz.ms@gmail.com"));
  
  display.display();
  delay(2000);

  display.clearDisplay();


// nastavení modulu
  scale.set_scale(calibration_factor); //Adjust to this calibration factor
  delay(100);
  scale.tare(); //Reset the scale to 0
  //long zero_factor = scale.read_average(); //Get a baseline reading
}

void loop() {

 // display.setFont(&FreeMono9pt7b);
 // display.setFont(&FreeSans9pt7b);
 // display.setFont(&FreeSans12pt7b);
 // display.setFont(&FreeSansBold9pt7b); 
 // display.setFont(&FreeSansBold12pt7b);
 // display.setFont(&FreeSansBold18pt7b);


if (napeti > 3.7) {

  display.setFont();
  display.setTextSize(1);      // Normal 1:1 pixel scale
  display.setTextColor(SSD1306_WHITE); // Draw white text
  display.setCursor(0, 0);     // Start at top-left corner
  display.println("Maximum ");
  display.setCursor(50, 0); 
  display.print(hmotnost_max, 2); 
  //display.println(" kg");
    
  display.setFont(&FreeSansBold18pt7b);
  display.setCursor(10, 42);
  display.print(abs(hmotnost_aktual), 1); 
  display.setFont(&FreeSansBold9pt7b);
  display.println(" kg");

  display.setFont();
  display.setTextSize(1);      // Normal 1:1 pixel scale
  display.setCursor(0, 55);     // Start at top-left corner
  display.println("Minimum ");
  display.setCursor(50, 55);
  display.print(abs(hmotnost_min), 2); 
  //display.println(" kg");

  // sloupec baterie
  display.setCursor(100, 55);
  napeti = bat / 219.0;
  display.print(napeti, 1);
  display.println("V");

  display.display();      // Show initial text
  
} else  {

  display.setCursor(10, 42);
  display.setFont(&FreeSansBold9pt7b);
  display.println("LOW BAT");

  // sloupec baterie
  display.setFont();
  display.setTextSize(1);      // Normal 1:1 pixel scale
  display.setCursor(100, 55);
  napeti = bat / 219.0;
  display.print(napeti, 1);
  display.println("V");

  display.display();      // Show initial text
 
}

  delay(250);
  display.clearDisplay();

  hmotnost_aktual = scale.get_units();
  
  if (hmotnost_max < hmotnost_aktual) hmotnost_max = hmotnost_aktual;
  if (hmotnost_min > hmotnost_aktual) hmotnost_min = hmotnost_aktual;  

  bat = analogRead(analogPin);

}

